/*****************************
 STEP18_CompareMode.c
*****************************/

// CN[ht@C̓ǂݍ
#include <pic.h>

// RtBM[V[h̐ݒ
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

// vg^Cv錾
void InitInterCCP (void);
void InitTimer1 (void);
void WaitTime (int cnt);

// C֐
void main (void)
{
	// 1,2,17,18[qo͒[qɐݒ
	CMCON = 0x07;
	
	// dx̏ݒ
	PORTA = 0xFF;
	PORTB = 0xFF;
	
	// o͐ݒ
	TRISA = 0x20;
	TRISB = 0x00;
	
	// CCPݐݒ֐̌Ăяo
	InitInterCCP();
	
	// ^C}1ݒ֐̌Ăяo
	InitTimer1();
	
	// Ӌ@\݂̋
	PEIE = 1;
	
	// Ŝ̊݋
	GIE = 1;
	
	// iv[v
	while(1)
	{
		// LED1Ԕ]
		RB1 = ~RB1;
		
		// ҂Ԋ֐̌Ăяo
		WaitTime(30000);
	}
}

// ݃T[rX[`
static void __interrupt() isr(void)
{
	// Xs[Jɓ͂dx𔽓]
	RB0 = ~RB0;

	// CCP݃tONA
	CCP1IF = 0;
}

// CCPݐݒ֐
void InitInterCCP (void)
{
	// CCP̃[hRyA[hiCCP + TMR1NAjɐݒ
	CCP1CON = 0b00001011;
	
	// CCPRWX^̐ݒi1911ʕbj
	CCPR1H = 0b00000111;
	CCPR1L = 0b01110111;
	
	// CCP݃tONA
	CCP1IF = 0;
	
	// CCP݂̋
	CCP1IE = 1;
}

// ^C}0ݒ֐
void InitTimer1 (void)
{
	// NbNNbNɐݒ
	TMR1CS = 0;
	
	// vXP[l1ɐݒ
	T1CKPS1 = 0;
	T1CKPS0 = 0;
	
	// TMRWX^NA
	TMR1H = 0;
	TMR1L = 0;
	
	// ^C}1N
	TMR1ON = 1;
}

// ҂Ԋ֐̌Ăяo
void WaitTime(int cnt)
{
	while(cnt > 0)
		cnt--;
}